void LCDswap()
{
  LCD0 = LC0; 
  LCD1 = LC1; 
  LCD2 = LC2; 
  LCD3 = LC3; 
  LCD4 = LC4; 
  LCD5 = LC5; 
  LCD6 = LC6; 
  LCD7 = LC7; 
}


void LCDskriv1(user1)  // write one 1 letter to LCD display
{
   LCDPORT = user1;
   LCDswap();
   ENA = 1;
   ENA = 0;
   Del(1);  // adjusted to max accepted writing speed 
}



void LCDgoto(user1)  // moves the invisble cursor position
{
   ENA = 0;
   RS  = 0;
   RW  = 0;
   LCDPORT = user1;
   LCDswap();
   ENA = 1;
   ENA = 0;
   Delay(2);
   RS  = 1;
}



void LCDsetgfx()  // user defined graphics carracters, for the bar-graf
{
  LCDgoto(GFXSET);
  
  LCDskriv1(0x00);  // 0 caracter code
  LCDskriv1(0x00);
  LCDskriv1(0x10);
  LCDskriv1(0x10);
  LCDskriv1(0x10);
  LCDskriv1(0x10);
  LCDskriv1(0x10);
  LCDskriv1(0x10);

  LCDskriv1(0x00);  // 1
  LCDskriv1(0x00);
  LCDskriv1(0x18);
  LCDskriv1(0x18);
  LCDskriv1(0x18);
  LCDskriv1(0x18);
  LCDskriv1(0x18);
  LCDskriv1(0x18);

  LCDskriv1(0x00);  // 2
  LCDskriv1(0x00);
  LCDskriv1(0x1c);
  LCDskriv1(0x1c);
  LCDskriv1(0x1c);
  LCDskriv1(0x1c);
  LCDskriv1(0x1c);
  LCDskriv1(0x1c);

  LCDskriv1(0x00);  // 3
  LCDskriv1(0x00);
  LCDskriv1(0x1e);
  LCDskriv1(0x1e);
  LCDskriv1(0x1e);
  LCDskriv1(0x1e);
  LCDskriv1(0x1e);
  LCDskriv1(0x1e);

  LCDskriv1(0x00);  // 4
  LCDskriv1(0x00);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);

  LCDskriv1(0x01);  // 5
  LCDskriv1(0x00);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);
  LCDskriv1(0x1F);

   ENA = 0;
   RS  = 1;
   RW  = 0;
   LCDPORT = 0x80;  // 1.digit
   LCDswap();
   ENA = 1;
   ENA = 0;
   Delay(3);
   RS  = 0;
}


void LCDinit()  // init of LCD display
{               // needs to be done on every LCD type, at power up
   ENA = 0;  // LCD control bits is difined in def.h
   RS  = 0;  
   RW  = 0;

   LCDPORT = 0x38;   // RESET, LCDPORT see def.h
   LCDswap();
   Delay(3);         
   ENA = 1; CLRWDT();  
   ENA = 0;
   Delay(20);

   ENA = 1; CLRWDT(); 
   ENA = 0;
   Delay(3);

   ENA = 1;CLRWDT(); 
   ENA = 0;
   Delay(3);

              // Display reset
   ENA = 1;CLRWDT(); 
   ENA = 0;
   Delay(3);


     // Display entry mode set
   LCDPORT = 0x06;  // 4 or 8 bits mode, 8 is choosen
   LCDswap();
   Delay(3);
   ENA = 1;CLRWDT(); 
   ENA = 0;
  
      // Display on
   LCDPORT = 0x0C;  // 0C = no cursor, no blink, defined here.
   LCDswap();
   Delay(3);
   ENA = 1;CLRWDT();
 
   LCDgoto(LINE1);
}



void LCDskriver(user2) // write a whole screen 20 x 2 
{                      // input is what text string number
  user1=0;  // pointer for text
  while (user1<20)
   {
     if (user2==6) LCDPORT = TEXT6[user1];
     else
     if (user2==7) LCDPORT = TEXT7[user1];
     else
     if (user2==8) LCDPORT = TEXT8[user1];
     else
     if (user2==9) LCDPORT = TEXT9[user1];
     else
     if (user2==15) LCDPORT = TEXT15[user1];
     else
     if (user2==16) LCDPORT = TEXT16[user1];
     else
     if (user2==17) LCDPORT = TEXT17[user1];
     else
     if (user2==18) LCDPORT = TEXT18[user1];
     else
     if (user2==19) LCDPORT = TEXT19[user1];
     LCDswap();
     ENA = 1;
     ENA = 0;
     Del(1);  
     user1++;
   }
}



void Welcome()
{
   LCDgoto(LINE1);
   LCDskriver(6); // the users define lines
   LCDgoto(LINE2);
   LCDskriver(8);
   user1=30;
   while (user1>=1)
   {
     Delay(51); 
     user1--;
   }
  LCDgoto(CLEAR);
}


void KonvSkriv()
{
  LCDskriv1(user2);
  LCDskriv1(user3);
  LCDskriv1(user4);
}
