void WriteBand()
{
    if (bandmode==0) 
    {
      LCDskriv1(' ');
      LCDskriv1('L');
    }
    else
    if (bandmode==1) 
    {
      LCDskriv1(' ');
      LCDskriv1('H');
    }
    else
    if (bandmode==2) 
    {
      LCDskriv1('V');
      LCDskriv1('H');
    }
    else
    if (bandmode==3) 
    {
      LCDskriv1('U');
      LCDskriv1('H');
    }
    else
    if (bandmode==4) 
    {
      LCDskriv1('S');
      LCDskriv1('H');
    }
    LCDskriv1('F');
}

void MessageNumber()
{
    if (messagenumber==0)
    {
      message1 = ' ';
      message2 = 'L';
      message3 = 'F';
      ActualCal = LFcal;
    }
    else
    if (messagenumber==1)
    {
      message1 = ' ';
      message2 = 'H';
      message3 = 'F';
      ActualCal = HFcal;
    }
    else
    if (messagenumber==2)
    {
      message1 = 'V';
      message2 = 'H';
      message3 = 'F';
      ActualCal = VHFcal;
    }
    else
    if (messagenumber==3)
    {
      message1 = 'U';
      message2 = 'H';
      message3 = 'F';
      ActualCal = UHFcal;
    }
    else
    if (messagenumber==4)
    {
      message1 = 'S';
      message2 = 'H';
      message3 = 'F';
      ActualCal = SHFcal;
    }
    else
    if (messagenumber==5)
    {
      message1 = 'I';
      message2 = 'N';
      message3 = 'A';
    }
    else
    if (messagenumber==6)
    {
      message1 = 'I';
      message2 = 'N';
      message3 = 'B';
    }
    else
    if (messagenumber==7)
    {
      message1 = 'A';
      message2 = 'T';
      message3 = 'T';
    }
    else
    if (messagenumber==8)
    {
      message1 = '0';
      message2 = 'd';
      message3 = 'B';
    }
    else
    if (messagenumber==9)
    {
      message1 = '-';
      message2 = '1';
      message3 = '0';
    }
    else
    if (messagenumber==10)
    {
      message1 = '-';
      message2 = '2';
      message3 = '0';
    }
    else
    if (messagenumber==11)
    {
      message1 = '-';
      message2 = '3';
      message3 = '0';
    }
    else
    if (messagenumber==12)
    {
      message1 = '-';
      message2 = '4';
      message3 = '0';
    }
    else
    if (messagenumber==13)
    {
      message1 = '-';
      message2 = '5';
      message3 = '0';
    }
}


void MessageUpdate()
{
  messagetimer++;
  if (displaydelay<30) user1 = 50;  // try to keep message update speed kinda constant
  else                              // not dedending on display delay
  user1 = 20;  
  if (messagetimer>=user1)  // info screen speed
  {
    messagetype++;
    messagetimer = 0;
    if (messagetype>=3) messagetype = 0;
  }
  if (messagetype == 0)
  {
    if (bandmode==0) messagenumber = 0;  // LF
    if (bandmode==1) messagenumber = 1;  // HF
    if (bandmode==2) messagenumber = 2;  // VHF
    if (bandmode==3) messagenumber = 3;  // UHF
    if (bandmode==4) messagenumber = 4;  // SHF
  }
  if (messagetype == 1) messagenumber = 7;  // ATT
  if (messagetype == 2)
  {
    if (attmode==0) messagenumber = 8;  // 0dB
    if (attmode==1) messagenumber = 9;  // -10dB
    if (attmode==2) messagenumber = 10;  // -20dB
    if (attmode==3) messagenumber = 11;  // -30dB
    if (attmode==4) messagenumber = 12;  // -40dB
    if (attmode==5) messagenumber = 13;  // -50dB
  }
  MessageNumber();
}


void ZeroCal()
{
  LCDgoto(CLEAR);
  LCDgoto(LINE1);
  LCDskriver(17);  // write the Erased info
  eeprom_write(0,0);  // erase first EEPROM location
  for (;;) NOP();   // wait for the watchdog to reset
}

void ReadCal()
{
  LCDgoto(CLEAR);
  LCDgoto(LINE1);
  LCDskriv1('C');  LCDskriv1('a');  LCDskriv1('l');  LCDskriv1('i');
  LCDskriv1('b');  LCDskriv1('.');  LCDskriv1('=');  LCDskriv1(' ');
  LCDskriv1('L');
  LCDskriv1('F');
  konv = LFcal;
  KONVERTER();
  KonvSkriv();
  LCDskriv1(' '); 
  LCDskriv1(' ');

  LCDskriv1('H');
  LCDskriv1('F');
  konv = HFcal;
  KONVERTER();
  KonvSkriv();  

  LCDgoto(LINE2);
  LCDskriv1('V');
  LCDskriv1('H');
  LCDskriv1('F');
  konv = VHFcal;
  KONVERTER();
  KonvSkriv(); 
  LCDskriv1(' '); 

  LCDskriv1('U');
  LCDskriv1('H');
  LCDskriv1('F');
  konv = UHFcal;
  KONVERTER();
  KonvSkriv(); 
  LCDskriv1(' '); 

  LCDskriv1('S');
  LCDskriv1('H');
  LCDskriv1('F');
  konv = SHFcal;
  KONVERTER();
  KonvSkriv(); 
  Delay(20);
  while (!BSEL) CLRWDT(); // wait intil button released
  Delay(20);
  while (BSEL) CLRWDT();  // wait for a button to be pressed 
}


void Calibrate()
{
  LCDgoto(CLEAR);
  LCDgoto(LINE1);
  if ((rfraw>605)&&(rfraw<850))  // check that input signal is within range.
  {
    LCDskriv1('C'); LCDskriv1('A'); LCDskriv1('L');
    LCDskriv1(' '); LCDskriv1('0'); LCDskriv1('d'); 
    LCDskriv1('B'); LCDskriv1('m'); LCDskriv1('=');
    konv = rfraw;
    KONVERTER();
    KonvSkriv();
    LCDgoto(LINE2);
    LCDskriv1('S'); LCDskriv1('t'); LCDskriv1('o'); LCDskriv1('r');
    LCDskriv1('e'); LCDskriv1('d'); LCDskriv1(' '); LCDskriv1('i');
    LCDskriv1('n'); LCDskriv1(' '); 
    if (bandmode==0) 
    {
      LFcal = rfraw;  // LF
      user1 = rfraw - 600;  // 600 is just the offset for the byte wide EEPROM 
      eeprom_write(0,user1);  // 600 is added again when reading the byte cal data
      LCDskriv1('L'); 
    }
    else
    if (bandmode==1) 
    {
      HFcal = rfraw;  // HF
      user1 = rfraw - 600;  // 600 is just the offset for the byte wide EEPROM 
      eeprom_write(1,user1);  // 600 is added again when reading the byte cal data
      LCDskriv1('H'); 
    }
    else
    if (bandmode==2) 
    {
      VHFcal = rfraw;  // VHF
      user1 = rfraw - 600;  // 600 is just the offset for the byte wide EEPROM 
      eeprom_write(2,user1);  // 600 is added again when reading the byte cal data
      LCDskriv1('V'); LCDskriv1('H');
    }
    else
    if (bandmode==3) 
    {
      UHFcal = rfraw;  // UHF
      user1 = rfraw - 600;  // 600 is just the offset for the byte wide EEPROM 
      eeprom_write(3,user1);  // 700 is added again when reading the byte cal data
      LCDskriv1('U'); LCDskriv1('H'); 
    }
    else
    if (bandmode==4) 
    {
      SHFcal = rfraw;  // SHF
      user1 = rfraw - 600;  // 600 is just the offset for the byte wide EEPROM 
      eeprom_write(4,user1);  // 600 is added again when reading the byte cal data
      LCDskriv1('S'); LCDskriv1('H'); 
    }
    LCDskriv1('F'); LCDskriv1(' ');
    LCDskriv1('B'); LCDskriv1('a'); LCDskriv1('n'); LCDskriv1('d');
  }
  else LCDskriver(18); // write Error message
  Delay100(20);
  messagetimer = 0;
  messagetype = 0;
}


void go_up()
{
  if (MENU) // in menu
  {
    menutype++;
    if (menutype>14) menutype = 14; 
  }
  else  // not in menu
  {
    bandmode++;
    if (bandmode>=5) bandmode = 4; 
    messagetimer = 0;
    messagetype = 0;
  }
  if (DISPSPD) displaydelay++;
}


void go_down()
{
  if (MENU) // in menu
  {
    menutype--;
    if (menutype>=128) menutype = 0; 
  }
  else
  {
    bandmode--;
    if (bandmode>=128) bandmode = 0; 
    messagetimer = 0;
    messagetype = 0;
  }
  if (DISPSPD) displaydelay--;
}

void EncoderActions()  // and buttons
{
    if (!BB) oldpos=0;  // if low
    
    if ((BB) && (oldpos==0)) // if hi and low before, positive edge
    {  
      if (BA) go_up();
      else go_down();
      if (displaydelay>=80) displaydelay = 80;
      if (displaydelay<=2) displaydelay = 2;
      Delay(5);    // debounce delay
      oldpos = 1;  // mark that it's hi
    }
    if (!BMENU) oldmenu = 0;
    if ((BMENU) && (oldmenu==0))
    {
      oldmenu = 1;
      MENU = !MENU;
    }
}


void DisplaySpeed()
{
  SLUT = FALSE;
  DISPSPD = TRUE;
  LCDgoto(CLEAR);
  LCDskriver(9);
  while(!SLUT)
  {
    if (!BSEL) SLUT = TRUE;
    EncoderActions();
    LCDgoto(LINE2);
    konv = displaydelay;
    KONVERTER();
    LCDskriv1(user3);
    LCDskriv1(user4);
    LCDskriv1('m');
    LCDskriv1('S');   LCDskriv1(' ');   LCDskriv1(' ');   LCDskriv1(' ');
    LCDskriv1(' ');   LCDskriv1(' ');   LCDskriv1(' ');
    LCDskriv1(' ');   LCDskriv1('S');   LCDskriv1('e');   LCDskriv1('l');
    LCDskriv1('e');   LCDskriv1('c');   LCDskriv1('t');
    LCDskriv1('=');   LCDskriv1('O');   LCDskriv1('K');
  }
  DISPSPD = FALSE;
  eeprom_write(10,displaydelay);  // save value in EEPROM for all eternaty
}



void MenuEnd()
{
   MENU = 0;  // exit menu
   Delay(20);
   while (!BSEL) CLRWDT(); // wait intil select button released
   Delay(20);
}

void MenuActions()
{
  LCDgoto(CLEAR);
  LCDgoto(LINE1);
  LCDskriv1('M'); LCDskriv1('e'); LCDskriv1('n'); LCDskriv1('u');
  LCDskriv1(':'); LCDskriv1(' ');
  LCDgoto(LINE2);
  LCDskriver(19);  // TEXT : Select = Activate
  while (MENU)
  {
    CLRWDT();
    GetADC();
    EncoderActions();
    LCDgoto(0x85);
    if (menutype==0) 
    {
      LCDskriv1(' '); LCDskriv1('0'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('0'); LCDskriv1('d');
      LCDskriv1('B'); LCDskriv1(' '); LCDskriv1(' ');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 0;
         eeprom_write(11,0);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==1) 
    {
      LCDskriv1(' '); LCDskriv1('1'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('-'); LCDskriv1('1');
      LCDskriv1('0'); LCDskriv1('d'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 1;
         eeprom_write(11,1);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==2) 
    {
      LCDskriv1(' '); LCDskriv1('2'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('-'); LCDskriv1('2');
      LCDskriv1('0'); LCDskriv1('d'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 2;
         eeprom_write(11,2);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==3) 
    {
      LCDskriv1(' '); LCDskriv1('3'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('-'); LCDskriv1('3');
      LCDskriv1('0'); LCDskriv1('d'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 3;
         eeprom_write(11,3);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==4) 
    {
      LCDskriv1(' '); LCDskriv1('4'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('-'); LCDskriv1('4');
      LCDskriv1('0'); LCDskriv1('d'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 4;
         eeprom_write(11,4);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==5) 
    {
      LCDskriv1(' '); LCDskriv1('5'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('t'); LCDskriv1('t');
      LCDskriv1('='); LCDskriv1('-'); LCDskriv1('5');
      LCDskriv1('0'); LCDskriv1('d'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = RF;
         attmode = 5;
         eeprom_write(11,5);  // save attenuator setting
         MenuEnd();
      }
    }
    else
    if (menutype==6) 
    {
      LCDskriv1(' '); LCDskriv1('6'); LCDskriv1(' '); 
      LCDskriv1('D'); LCDskriv1('C'); LCDskriv1(' ');
      LCDskriv1('V'); LCDskriv1('o'); LCDskriv1('l');
      LCDskriv1('t'); LCDskriv1('M'); LCDskriv1('e');
      LCDskriv1('t'); LCDskriv1('e'); LCDskriv1('r');

      if (BSEL==0)  // the select button
      {
         metertype = DC;
         MenuEnd();
      }
    }
    else
    if (menutype==7) 
    {
      LCDskriv1(' '); LCDskriv1('7'); LCDskriv1(' '); 
      LCDskriv1('R'); LCDskriv1('F'); LCDskriv1(' ');
      LCDskriv1('P'); LCDskriv1('o'); LCDskriv1('w');
      LCDskriv1('.'); LCDskriv1('M'); LCDskriv1('e');
      LCDskriv1('t'); LCDskriv1('e'); LCDskriv1('r');

      if (BSEL==0)  // the select button
      {
         metertype = RF;
         MenuEnd();
      }
    }
    else
    if (menutype==8) 
    {
      LCDskriv1(' '); LCDskriv1('8'); LCDskriv1(' '); 
      LCDskriv1('S'); LCDskriv1('S'); LCDskriv1('B');
      LCDskriv1(' '); LCDskriv1('P'); LCDskriv1('E');
      LCDskriv1('P'); LCDskriv1(' '); LCDskriv1('W');
      LCDskriv1('a'); LCDskriv1('t'); LCDskriv1('t');

      if (BSEL==0)  // the select button
      {
         metertype = SSB;
         MenuEnd();
      }
    }

    else
    if (menutype==9) 
    {
      LCDskriv1(' '); LCDskriv1('9'); LCDskriv1(' '); 
      LCDskriv1('R'); LCDskriv1('T'); LCDskriv1('N');
      LCDskriv1('.'); LCDskriv1('L'); LCDskriv1('o');
      LCDskriv1('s'); LCDskriv1('s'); LCDskriv1(' ');
      LCDskriv1('S'); LCDskriv1('W'); LCDskriv1('R');

      if (BSEL==0)  // the select button
      {
         metertype = RTN;
         RelativeCal = rfraw;  // store relative zero value
         MenuEnd();
      }
    }
    else
    if (menutype==10) 
    {
      LCDskriv1('1'); LCDskriv1('0'); LCDskriv1(' '); 
      LCDskriv1('C'); LCDskriv1('a'); LCDskriv1('l');
      LCDskriv1(' '); LCDskriv1('0'); LCDskriv1('d');
      LCDskriv1('B'); LCDskriv1('m'); LCDskriv1(' ');
      WriteBand();
      if (BSEL==0)  // the select button
      {
        Calibrate();
        metertype = RF;
        MENU = 0;
      }
    }
    else
    if (menutype==11) 
    {
      LCDskriv1('1'); LCDskriv1('1'); LCDskriv1(' '); 
      LCDskriv1('R'); LCDskriv1('e'); LCDskriv1('a');
      LCDskriv1('d'); LCDskriv1(' '); LCDskriv1('C');
      LCDskriv1('a'); LCDskriv1('l'); LCDskriv1('D');
      LCDskriv1('a'); LCDskriv1('t'); LCDskriv1('a');
      if (BSEL==0)  // the select button
      {
        ReadCal();
        metertype = RF;
        MENU = 0;
      }
    }
    else
    if (menutype==12) 
    {
      LCDskriv1('1'); LCDskriv1('2'); LCDskriv1(' '); 
      LCDskriv1('Z'); LCDskriv1('e'); LCDskriv1('r');
      LCDskriv1('o'); LCDskriv1(' '); LCDskriv1('A');
      LCDskriv1('l'); LCDskriv1('l'); LCDskriv1(' ');
      LCDskriv1('C'); LCDskriv1('a'); LCDskriv1('l');
      if (BSEL==0)  // the select button
      {
        ZeroCal();  // ends with a watchdog reset !
      }
    }
    else
    if (menutype==13) 
    {
      LCDskriv1('1'); LCDskriv1('3'); LCDskriv1(' '); 
      LCDskriv1('D'); LCDskriv1('i'); LCDskriv1('s');
      LCDskriv1('p'); LCDskriv1('l'); LCDskriv1('a');
      LCDskriv1('y'); LCDskriv1('S'); LCDskriv1('p');
      LCDskriv1('e'); LCDskriv1('e'); LCDskriv1('d');
      if (BSEL==0)  // the select button
      {
        MenuEnd();  // be sure that select button is released
        DisplaySpeed();
        metertype = RF;
        MenuEnd();
      }
    }
    else
    if (menutype==14) 
    {
      LCDskriv1('1'); LCDskriv1('4'); LCDskriv1(' '); 
      LCDskriv1('A'); LCDskriv1('b'); LCDskriv1('o');
      LCDskriv1('u'); LCDskriv1('t'); LCDskriv1(' ');
      LCDskriv1('i'); LCDskriv1('n'); LCDskriv1('f');
      LCDskriv1('o'); LCDskriv1(' '); LCDskriv1(' ');
      if (BSEL==0)  // the select button
      {
         metertype = ABOUT;
         MenuEnd();
      }
    }
  }  // end while menu
  LCDgoto(CLEAR);  // at exit menu
}


