// By oz2cpu
// all ADC 

void GetADC()
{
    ADGO = 1;        // start RF A level converting
    while(ADGO) CLRWDT();  // wait for AD converter to be done
    rfraw = (ADRESL+(ADRESH*256));   // get result from adres L=8bit H=2bit
    CHS2 = 0; CHS1 = 1;
    CHS0 = 0;  // Select AN2 input RF B 
    if (metertype==SSB)
    {
      if (rfraw > peak)  // if measured value is bigger than displayed value
      {                  // copy value
        peak = rfraw;
        peakholddelay = 50;
      }
      rfraw = peak;  // store the peak value so that all old modules uses this value.
    }
    konv = rfraw;  // RF input A
    KONVERTER();   
    Ser1(user1); Ser1(user2); Ser1(user3); Ser1(user4);
    Ser1(' '); 

    ADGO = 1;        // start RF B level converting
    while(ADGO) CLRWDT();  // wait for AD converter to be done
    rfrawB = (ADRESL+(ADRESH*256));   // get result from adres L=8bit H=2bit
    CHS2 = 0; CHS1 = 0;
    CHS0 = 0;  // Select AN0 input Volt 
    konv = rfrawB;  // RF input B
    KONVERTER();   
    Ser1(user1); Ser1(user2); Ser1(user3); Ser1(user4);
    Ser1(' '); 

    ADGO = 1;        // start VOLT converting
    while(ADGO) CLRWDT();  // wait for AD converter to be done
    voltraw = (ADRESL+(ADRESH*256));   // get result from adres L=8bit H=2bit
    CHS2 = 0; CHS1 = 0;
    CHS0 = 1;  // Select AN1 input RF Level 
    konv = voltraw;
    KONVERTER();   
    Ser1(user1); Ser1(user2); Ser1(user3); Ser1(user4);
    Ser1(10);  Ser1(13); 

}
