// All measure and display routines

void WriteWattmeter()
{
    if (rfraw2<=99)
    {
      wpointer=rfraw2;  // pointer to Watt table 0-100 positions
      wpref='p';       // pico Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=199)
    {
      wpointer=rfraw2-100;  // pointer to Watt table 0-100 positions
      wpref='p';       // pico Watt
      wpoint = 4;      // where to place the point .
    }
    else
    if (rfraw2<=299)
    {
      wpointer=rfraw2-200;  // pointer to Watt table 0-100 positions
      wpref='n';       // pico Watt
      wpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=399)
    {
      wpointer=rfraw2-300;  // pointer to Watt table 0-100 positions
      wpref='n';       // nano Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=499)
    {
      wpointer=rfraw2-400;  // pointer to Watt table 0-100 positions
      wpref='n';       // nano Watt
      wpoint = 4;      // where to place the point .
    }
    else
    if (rfraw2<=599)
    {
      wpointer=rfraw2-500;  // pointer to Watt table 0-100 positions
      wpref='u';       // micro Watt
      wpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=699)
    {
      wpointer=rfraw2-600;  // pointer to Watt table 0-100 positions
      wpref='u';       // micro Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=799)
    {
      wpointer=rfraw2-700;  // pointer to Watt table 0-100 positions
      wpref='u';       // micro Watt
      wpoint = 4;      // where to place the point .
    }
    else
    if (rfraw2<=899)
    {
      wpointer=rfraw2-800;  // pointer to Watt table 0-100 positions
      wpref='m';       // milli Watt
      wpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=999)
    {
      wpointer=rfraw2-900;  // pointer to Watt table 0-100 positions
      wpref='m';       // milli Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=1099)
    {
      wpointer=rfraw2-1000;  // pointer to Watt table 0-100 positions
      wpref='m';       // milli Watt
      wpoint = 4;      // where to place the point .
    }
    else
    if (rfraw2<=1199)
    {
      wpointer=rfraw2-1100;  // pointer to Watt table 0-100 positions
      wpref=' ';       // Watt
      wpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=1299)
    {
      wpointer=rfraw2-1200;  // pointer to Watt table 0-100 positions
      wpref=' ';       //  Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=1399)
    {
      wpointer=rfraw2-1300;  // pointer to Watt table 0-100 positions
      wpref=' ';       // Watt
      wpoint = 4;      // where to place the point .
    }
    else
    if (rfraw2<=1499)
    {
      wpointer=rfraw2-1400;  // pointer to Watt table 0-100 positions
      wpref='k';       // Watt
      wpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=1599)
    {
      wpointer=rfraw2-1500;  // pointer to Watt table 0-100 positions
      wpref='k';       // Watt
      wpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=1699)
    {
      wpointer=rfraw2-1600;  // pointer to Watt table 0-100 positions
      wpref='k';       // Watt
      wpoint = 4;      // where to place the point .
    }
      w1=wten[wpointer];  // get absolutte part from table
      w2=wdec[wpointer];  // get decimal part from table
      konv = 0;
      konv = w1;
      KONVERTER();
      if (wpoint==4) LCDskriv1(' ');
      LCDskriv1(user4);
      if (wpoint==2) LCDskriv1('.');  // if this is the right place, write the point
      konv = w2;
      KONVERTER();
      LCDskriv1(user3);
      if (wpoint==3) LCDskriv1('.');  // if this is the right place, write the point
      LCDskriv1(user4);
      LCDskriv1(wpref);   
      LCDskriv1('W');  
}


void BarGraph()
{
    user2 = 1;  // carracter pointer
    user1 = (rfraw/10);  // now max rf level is 100 
    while (user1>=5)  // how meny full black carracters to draw
    {
      LCDskriv1(4);
      user1=user1-5;
      user2++;
    }
    if (user1==5) LCDskriv1(4);  // Draw the last carracter
    else
    if (user1==4) LCDskriv1(3);
    else
    if (user1==3) LCDskriv1(2);
    else
    if (user1==2) LCDskriv1(1);
    else
    if (user1==1) LCDskriv1(0);
}


void BarEraseRest()
{
    while (user2<=20)  // erase the rest
    {
      LCDskriv1(' ');
      user2++;
    } 
}

void BarGraphHI()  // write the hight part
{
    WriteWattmeter();
    LCDskriv1(' ');

    LCDgoto(0xc7);

    user2 = 7;  // carracter pointer
    user1 = (rfraw/10);   // now max rf level is 100 
    user1 = user1-user2*5;  // find real starting point
    while (user1>=5)  // how meny full black carracters to draw
    {
      LCDskriv1(4);
      user1=user1-5;
      user2++;
    }
    if (user1==5) LCDskriv1(4);  // Draw the last carracter
    else
    if (user1==4) LCDskriv1(3);
    else
    if (user1==3) LCDskriv1(2);
    else
    if (user1==2) LCDskriv1(1);
    else
    if (user1==1) LCDskriv1(0);
}


void WriteRFVolt()
{
    if (rfraw2<=199)
    {
      vpointer=rfraw2;  // pointer to Watt table 0-100 positions
      vpref='u';       // Mirco Volt
      vpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=399)
    {
      vpointer=rfraw2-200;  // pointer to Watt table 0-100 positions
      vpref='m';       // milli Volt
      vpoint = 1;      // where to place the point .
    }
    else
    if (rfraw2<=599)
    {
      vpointer=rfraw2-400;  // pointer to Watt table 0-100 positions
      vpref='m';       // milli Volt
      vpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=799)
    {
      vpointer=rfraw2-600;  // pointer to Watt table 0-100 positions
      vpref='m';       // milli Volt
      vpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=999)
    {
      vpointer=rfraw2-800;  // pointer to Watt table 0-100 positions
      vpref=' ';       // Volt
      vpoint = 1;      // where to place the point .
    }
    else
    if (rfraw2<=1199)
    {
      vpointer=rfraw2-1000;  // pointer to Watt table 0-100 positions
      vpref=' ';       // Volt
      vpoint = 2;      // where to place the point .
    }
    else
    if (rfraw2<=1399)
    {
      vpointer=rfraw2-1200;  // pointer to Watt table 0-100 positions
      vpref=' ';       // Volt
      vpoint = 3;      // where to place the point .
    }
    else
    if (rfraw2<=1599)
    {
      vpointer=rfraw2-1400;  // pointer to Watt table 0-100 positions
      vpref='k';       // Volt
      vpoint = 1;      // where to place the point .
    }
    else
    if (rfraw2<=1799)
    {
      vpointer=rfraw2-1600;  // pointer to Watt table 0-100 positions
      vpref='k';       // Volt
      vpoint = 2;      // where to place the point .
    }


      v1=vten[vpointer];  // get absolutte part from table
      v2=vdec[vpointer];  // get decimal part from table
      konv = v1;
      KONVERTER();
      if (vpoint==0)
      {
        LCDskriv1('0');
        LCDskriv1('.');  // if this is the right place, write the point
      }
      LCDskriv1(user2);
      if (vpoint==1) LCDskriv1('.');  // if this is the right place, write the point
      LCDskriv1(user3);
      if (vpoint==2) LCDskriv1('.');  // if this is the right place, write the point
      LCDskriv1(user4);
      if (vpoint==3) LCDskriv1('.');  // if this is the right place, write the point

      konv = v2;
      KONVERTER();
      LCDskriv1(user3);
      LCDskriv1(vpref);   
      LCDskriv1('V');  
}


void WriteDBM()
{
  if (RELATIVE)
  {      
    if (rfraw>=RelativeCal)
    {
      rfdbm = rfraw-RelativeCal;
      dbswr = 0;  // the return loss and swr value does not have a meaning at +dB
      if (rfdbm>6) SWRERROR = TRUE;
      else SWRERROR = FALSE;
      LCDskriv1('+');  // this can also be changed to a space
    }
    else
    {
      rfdbm = RelativeCal-rfraw;
      dbswr = rfdbm/10;
      SWRERROR = FALSE;
      LCDskriv1('-');  
    }
  }
  else  // absolute dBm read out
  {  
    if (attmode==0) rfRawAtt=rfraw;  // add nothing if no att. is mounted
    if (attmode==1) rfRawAtt=rfraw+100;  // add 10dB if 10dB att. is mounted
    if (attmode==2) rfRawAtt=rfraw+200;  // add 20dB if 20dB att. is mounted
    if (attmode==3) rfRawAtt=rfraw+300;  // add 30dB if 30dB att. is mounted
    if (attmode==4) rfRawAtt=rfraw+400;  // add 40dB if 40dB att. is mounted
    if (attmode==5) rfRawAtt=rfraw+500;  // add 50dB if 50dB att. is mounted

    if (rfRawAtt>=ActualCal)
    {
      rfdbm = rfRawAtt-ActualCal;
      rfraw2 = 800 + rfdbm;  // calibrated raw to volt and power
      LCDskriv1('+');  // this can also be changed to a space
    }
    else
    {
      rfdbm = ActualCal-rfRawAtt;
      rfraw2 = 800 - rfdbm;  // used for the look-up tabels
      LCDskriv1('-');  
    }
  } 
  konv = rfdbm;
  KONVERTER();
  LCDskriv1(user2); LCDskriv1(user3); 
  LCDskriv1('.');  LCDskriv1(user4);  LCDskriv1('d');  LCDskriv1('B'); 

  if (RELATIVE) LCDskriv1(' ');
  else LCDskriv1('m');
}


void WriteDCmeter()
{
    konv = voltraw*2;
    KONVERTER(); 
    if (user1=='0')  LCDskriv1(' ');
    else
    LCDskriv1(user1);
    LCDskriv1(user2);  LCDskriv1('.');
    LCDskriv1(user3); LCDskriv1(user4);
    LCDskriv1('V');  LCDskriv1(' ');
    LCDskriv1(' ');  LCDskriv1('S'); LCDskriv1('e'); LCDskriv1('l'); 
    LCDskriv1('e');  LCDskriv1('c'); LCDskriv1('t');
    LCDskriv1('=');  LCDskriv1('R'); LCDskriv1('e'); LCDskriv1('s');
    LCDskriv1('e');  LCDskriv1('t');  

    if (BSEL==0)  // the select button
    {
      voltmin=voltraw;
      voltmax=voltraw;
    }

    if (voltmin>voltraw) voltmin=voltraw;
    if (voltmax<voltraw) voltmax=voltraw;
    LCDgoto(LINE2);
    LCDskriv1('M');    LCDskriv1('i');    LCDskriv1('n'); LCDskriv1('=');
    konv = voltmin*2;
    KONVERTER(); 
    if (user1=='0')  LCDskriv1(' ');
    else
    LCDskriv1(user1);
    LCDskriv1(user2);  LCDskriv1('.');
    LCDskriv1(user3); LCDskriv1(user4);
 
    LCDskriv1(' '); LCDskriv1(' ');

    LCDskriv1('M');    LCDskriv1('a');    LCDskriv1('x'); LCDskriv1('=');
    konv = voltmax*2;
    KONVERTER(); 
    if (user1=='0')  LCDskriv1(' ');
    else
    LCDskriv1(user1);
    LCDskriv1(user2);  LCDskriv1('.');
    LCDskriv1(user3); LCDskriv1(user4);

}


void WriteRFmeter()
{
    WriteDBM();
    if (!BSEL)
    {
      while (!BSEL) CLRWDT();  // wait for select to be released 
      RELATIVE=!RELATIVE;     // togle relative bit
      if (RELATIVE) RelativeCal=rfraw;  // store relative zero value
      Delay(20);
    }
    EncoderActions();
    LCDskriv1(' '); 
    if (RELATIVE)
    {
      LCDskriv1(' ');
      LCDskriv1('R');
      LCDskriv1('E');
      LCDskriv1('L');
      LCDskriv1('A');
      LCDskriv1('T');
      LCDskriv1('I');
      LCDskriv1('V');
      LCDskriv1('E');
      LCDskriv1(' ');
      LCDskriv1(' ');
      LCDgoto(LINE2);
      BarGraph(); // and no Wattmeter
      BarEraseRest();
    }
    else
    {
      LCDskriv1(message1);
      LCDskriv1(message2);
      LCDskriv1(message3);
      LCDskriv1(' '); 
      EncoderActions();
      WriteRFVolt();
      EncoderActions();
      LCDskriv1(' '); 
      LCDgoto(LINE2);
      if (rfraw>=575) BARGLO = TRUE;
      if (rfraw<=545) BARGLO = FALSE;
      EncoderActions();
      if (BARGLO)
      {
        BarGraphHI();  // and Wattmeter
        BarEraseRest();
      }
      else
      {
        BarGraph();
        while (user2<=14)  // erase the rest
        {
          LCDskriv1(' ');
          user2++;
        } 
        LCDgoto(0xce);
        WriteWattmeter();
        LCDskriv1(' ');
      }
   }
}



void WriteSSBmeter()
{
  WriteDBM();
  EncoderActions();
  LCDskriv1(' '); 
  LCDskriv1(message1);
  LCDskriv1(message2);
  LCDskriv1(message3);
  LCDskriv1(' '); 
  WriteWattmeter(); 
 
  LCDgoto(LINE2);
  BarGraph(); // and no Wattmeter
  BarEraseRest();

  if (peakholddelay >= 10) peakholddelay--;
  else
  {
    if (peak >=10) peak--;  // decay, make sure the peak value can not go under 10
  }
}




void WriteRTNmeter()
{
   RELATIVE = 1;
   WriteDBM();
   if (!BSEL)
   {
     while (!BSEL) CLRWDT();  // wait for select to be released 
     RelativeCal = rfraw;  // store relative zero value
     Delay(20);
   }

   LCDskriv1(' ');
   LCDskriv1('R');
   LCDskriv1('E');
   LCDskriv1('T');
   LCDskriv1('U');
   LCDskriv1('R');
   LCDskriv1('N');
   LCDskriv1(' ');
   LCDskriv1('L');
   LCDskriv1('O');
   LCDskriv1('S');
   LCDskriv1('S');

   LCDgoto(LINE2);
   if (dbswr<=60);  // check value is within table size, else crash !!
   {
     user1 = swrconv[dbswr];  // get swr value from table
     konv = user1;
     KONVERTER();
     user5 = '.';
     user2++;  // add 1 to the hundred
     user1=' ';
   }
   if (dbswr>=61)
   {
     user1='-'; user2='-';
     user5='.'; 
     user3='-'; user4='-';
   }
   if (dbswr==0) { user1='C'; user2='A'; user5='L'; user3='E'; user4='D'; }
   else
   if (dbswr==1) { user1='1'; user2='7'; user5='.'; user3='3'; user4='9'; }
   else
   if (dbswr==2) { user1=' '; user2='8'; user5='.'; user3='7'; user4='2'; }
   else
   if (dbswr==3) { user1=' '; user2='5'; user5='.'; user3='8'; user4='4'; }
   else
   if (dbswr==4) { user1=' '; user2='4'; user5='.'; user3='4'; user4='2'; }
   else
   if (dbswr==5) { user1=' '; user2='3'; user5='.'; user3='5'; user4='7'; }
   if (SWRERROR) { user1='E'; user2='R'; user5='R'; user3='O'; user4='R'; }

   LCDskriv1(user1); LCDskriv1(user2);
   LCDskriv1(user5); 
   LCDskriv1(user3); LCDskriv1(user4);
   LCDskriv1(' '); 
   LCDskriv1('S');
   LCDskriv1('W');
   LCDskriv1('R');
   LCDskriv1(' ');
   LCDskriv1(' ');
   LCDskriv1(' ');
   LCDskriv1('S');
   LCDskriv1('E');
   LCDskriv1('L');
   LCDskriv1('=');
   LCDskriv1('Z');
   LCDskriv1('E');
   LCDskriv1('R');
   LCDskriv1('O');
}
